<?php
require_once('vb_api_client.php');
require_once('config.php');

final class UserInfo {         
    public static function all() {
		return array_values(@$_SESSION['UserInfo']);
	}
	public static function get($vb_name) {
        if(isset($_SESSION['UserInfo'][$vb_name])) {
            return $_SESSION['UserInfo'][$vb_name];
        }     
        return new UserInfo($vb_name);
    }
    
    public static function set($user) {
        $_SESSION['UserInfo'][$user->getVBUsername()] = $user;
    }
    
    private $vb_avatarurl;
    private $vb_username;
    private $vb_usertitle;
    private $vb_userid;
    private $fb_username;
    private $fb_userid;
	private $is_fb_friend;
	
	private $have_done_member = false;
    
    private function __construct($name) {
        $this->vb_username = $name;
    }
    public function getAvatarUrl() {
        if($this->hasFBData()) {
            return $this->getFBAvatarUrl();
        }
        return $this->getVBAvatarUrl();
    }
    public function getProfileUrl() {
        if($this->hasFBData()) {
            return $this->getFBProfileUrl();
        }
        return $this->getVBProfileUrl();
    }
    public function hasFBData() {
        return isset($this->fb_userid);
    }
    public function getVBUsername() {
        return $this->vb_username;
    }
    public function getVBUserId($do_member_lookup = true) {
        if(!isset($this->vb_userid) and $do_member_lookup) {
			$this->member();
		}
        return $this->vb_userid;
    }
    public function setVBUserId($vb_userid) {
        $this->vb_userid = $vb_userid;
    }
    
     public function getVBUsertitle($do_member_lookup = true) {
        if(!isset($this->vb_usertitle) and $do_member_lookup) {
			$this->member();
		}
        return $this->vb_usertitle;
    }
    public function setVBUsertitle($vb_usertitle) {
        $this->vb_usertitle = $vb_usertitle;
    }
    
    public function getFBUserId() {
        return $this->fb_userid;
    }
    public function setFBUserId($fb_userid) {
        $this->fb_userid = $fb_userid;
    }
    public function getFBUsername() {
        if(!isset($this->fb_username) && isset($this->fb_userid)) {
            // get from graph?
        }
        return $this->fb_username;
    }   
    public function getVBAvatarUrl($do_member_lookup = true) {
        if(!isset($this->vb_avatarurl) and $do_member_lookup and !$this->have_done_member) {
			$this->member();
		}
		return vB_SITE_ROOT . (!empty($this->vb_avatarurl) ? $this->vb_avatarurl : 'images/misc/unknown.gif');
    }
    public function setVBAvatarUrl($vb_avatarurl) {
        $this->vb_avatarurl = $vb_avatarurl;
    }
    public function getFBAvatarUrl() {
        return "http://graph.facebook.com/" . $this->getFBUserId() . "/picture";
    }
    public function getVBProfileUrl() {
        return vB_SITE_ROOT . 'member.php?username=' . $this->getVbUsername();
    }
    public function getFBProfileUrl() {
        return 'http://www.facebook.com/profile.php?id=' . $this->getFBUserId();
    }
	
	public function isFBFriend() {
		return $this->is_fb_friend;
	}
	public function setIsFBFriend($fb_friend) {
		$this->is_fb_friend = $fb_friend;
	}
	
	private function member() {
		// Do not allow this lookup to slow us down too much. This comes at the cost of correctness.
		// If we must be gauranteed have one of these values, add it to the API call where the data originates.
		if(VBApiClient::instance()->timeInAPIThisRequest() <= 0.001) {
			$json = json_decode(VBApiClient::instance()->call_cached_session('member', array(), array('username' => $this->vb_username)), true);
			
			$this->vb_userid = 		@$json['response']['prepared']['userid'];
			$this->vb_avatarurl = 	@$json['response']['prepared']['avatarurl'];
			$this->vb_usertitle = 	@$json['response']['prepared']['usertitle'];
			
			self::set($this);
		}
	}
}
?>